#!/usr/bin/python

collector = dict()
out = file("crpdfig2.dat", "wt")

KEYS1 = ["real", "good", "poor", "loblock"]
KEYS3 = ["srpd", "srpd-crpd", "crpd-srpd"]

for key1 in KEYS1:
    fname = "experiment/section4/%s.csv" % key1
    n = 0
    for line in file(fname):
        fields = line.split()
        for data in fields[2:]:
            n = max(int(data), n)

    assert n > 0
    n = float(n)

    for line in file(fname):
        fields = line.split()
        key2 = fields[1] # The utilisation

        if collector.has_key(('', key2, 'crpd')):
            assert collector[('', key2, 'crpd')] == (float(fields[2]) / n), (
                    "Difference in CRPD for key %s -- %1.4e %1.4e" % (
                        key2, collector[('', key2, 'crpd')], 
                        float(fields[2]) / n))
        else:
            collector[('', key2, 'crpd')] = float(fields[2]) / n

        collector[(key1, key2, "srpd")] = float(fields[3]) / n
        collector[(key1, key2, "srpd-crpd")] = float(fields[4]) / n
        collector[(key1, key2, "crpd-srpd")] = float(fields[5]) / n

for u in xrange(30, 101):
    key2 = "%1.2f" % (u / 100.0)

    out.write('%s %7.4f' % (key2, collector[('', key2, 'crpd')]))
    for key3 in KEYS3:
        for key1 in KEYS1:
            out.write(' %7.4f' % collector[(key1, key2, key3)])
    out.write("\n")

out.close()

print 'crpdfig2.dat columns:'
print '1. utilisation'
print '2. CRPD'
x = 3
for key3 in KEYS3:
    for key1 in KEYS1:
        print '%u. %s for %s' % (x, key3.upper(), key1)
        x += 1

