#!/usr/bin/python

import subprocess, sys, os

def call(args):
    rc = 0
    try:
        rc = subprocess.call(args)
        rc = rc >> 8
    except OSError, e:
        print str(e)
        print args[0]
        rc = 1

    return rc

args = ["mb-gcc", "-S"]
asm_name = None
obj_name = None
out = False
c_compile = False
for arg in sys.argv[1:]:
    arg = arg.strip()
    if arg in ["", "-c"]:
        continue
    if out:
        obj_name = arg
        (arg, _) = os.path.splitext(arg)
        arg += ".s"
        asm_name = arg
        out = False
    elif arg == "-o":
        out = True
    elif arg.endswith(".c") and os.path.exists(arg):
        c_compile = True

    args.append(arg)

if not c_compile:
    rc = call([args[0]] + sys.argv[1:])
    sys.exit(rc)

assert asm_name != None
assert obj_name != None

rc = call(args)
if rc != 0:
    sys.exit(rc)

rebuild = []
for line in file(asm_name):
    rebuild.append(line.replace("brlid", "bralid"))

file(asm_name, "wt").write(''.join(rebuild))
args = [args[0], "-o", obj_name, "-c", asm_name]
rc = subprocess.call(args)
sys.exit(rc)

