#define FROM_ASM
#include "rtos.h"


.global memmove
.global memcpy
.global get_time
.global set_trigger
.global spm_loader
.global get_hires_timer
.global print
.global the_block_size_is
.global the_num_blocks_is
.global sw_log_event

TRANSACTION_SIZE = BLOCK_SIZE
the_block_size_is = BLOCK_SIZE
the_num_blocks_is = NUM_BLOCKS

        .section	.kernelstuff.t,"ax",@progbits
memcpy:
memmove: # r5 is dest
        # r6 is source
        # r7 is size

        beqid   r7, 1f      # Nothing to copy?
        addi    r4, r7, -1
        lbu     r3, r6, r4

0:
        sb      r3, r5, r4
        addi    r4, r4, -1
        bneid   r4, 0b
        lbu     r3, r6, r4

        sb      r3, r5, r4
1:  
        rtsd    r15, 8
        or      r3, r5, r0

get_time:
        rtsd    r15, 8
        get     r3, rfsl1

set_trigger:
        rtsd    r15, 8
        cput    r5, rfsl1



print:  # r5 - string to output
        .long   CMD_PRNT # print notify
        addi    r6, r0, UART_BASE
2:      lbui    r7, r5, 0       # Load next byte
        beqi    r7, 1f          # Exit if zero
0:      # Wait for UART ready
        lwi     r3, r6, 8       # Read status
        andi    r3, r3, 8
        bnei    r3, 0b
        swi     r7, r6, 4       # Write byte
        brid    2b              
        addi    r5, r5, 1       # Advance through string
1:      # Finished
        # Wait for UART ready again
        lwi     r3, r6, 8       # Read status
        andi    r3, r3, 4
        beqi    r3, 1b
        rtsd    r15, 8
        nop


