import vlab
import sys
from twisted.internet import reactor, defer
from vlab import terminal

class DT1(terminal.DumbTerminal):
    def write(self, data):
        if (( "\x03" in data )
        or ( "\x04" in data )):
            print ""
            print "Exit"
            reactor.stop()
        else: 
            terminal.DumbTerminal.write(self, data)

@defer.inlineCallbacks
def twisted_run(program, output):
    print 'Loading bit file'
    bits = file("implementation/download.bit", "rb").read()
    #bits = file("fpga0.bit", "rb").read()

    print 'Connecting to the board'
    auth = vlab.loadAuthorisation("/home/jack/jack-vl3.key")
    vlf = vlab.VlabClientFactory(auth, debug = False)
    reactor.connectTCP(auth.relay_server_name, 22, vlf)
    vl = yield vlf.getChannel()
    yield vl.connect("ml505")
    yield vl.setUART(0, 115200)
   
    print 'Sending bit file'
    bid = yield vl.sendBitfile(bits)
    print 'Bid is', bid
    uart = vlab.VlabUARTProtocol()
    yield vl.programFPGAopenUART(0, bid, 0, uart)

    #print 'Hit it when ready'
    #sys.stdin.readline()

    print 'Startup'
    data = yield uart.read(1)
    last_bytes = "xxxxxx" + data
    counter = 0
    while last_bytes != "end hex":
        sys.stdout.write(data)
        sys.stdout.flush()
        counter += 1
        data = yield uart.read(1)
        last_bytes = last_bytes[1:] + data

    uart.write(program)

    last_bytes = "xxxxx" + data
    counter = 0
    while last_bytes != "- boot":
        sys.stdout.write(data)
        sys.stdout.flush()
        counter += 1
        data = yield uart.read(1)
        last_bytes = last_bytes[1:] + data

    last_bytes = "xx" + data
    counter = 0
    data = yield uart.read(1)

    while (counter < 100) or (last_bytes != "\xfe\r\n"):
        if data != "\xfe":
            sys.stdout.write(data)
            sys.stdout.flush()

        counter += 1

        output.write(data)
        output.flush()
        data = yield uart.read(1)
        last_bytes = last_bytes[1:] + data

    print '\r', repr(last_bytes)
    reactor.stop()


def run(program_ihex_file, log_file):
    reactor.addSystemEventTrigger('after', 'startup', twisted_run,
            file(program_ihex_file).read(),
            file(log_file, "wt"))
    reactor.run()


