#!/usr/bin/python

import struct

for size in [2, 4, 8]:
    cache_sets = (size * 1024 / 16)
    print size
    out = []
    for line in file("ecb-%ukb.txt" % size):
        fields = line.split()
        name = fields.pop(0)

        name = {
                "bs":"binarysearch",
                "qsort-exam":"qsortexam",
                }.get(name, name)

        assert len(fields) == cache_sets
        altmeyer = set()
        for (i, x) in enumerate(fields):
            assert x in "01"
            if x == "1":
                altmeyer.add(i)

        trace2 = file("traces/%s.bt" % name, "rb")
        word = trace2.read(4)

        whitham = set()
        while len(word) == 4:
            (address, ) = struct.unpack("<I", word)
            line = ((address) >> 4) & (cache_sets - 1)
            whitham.add(line)

            word = trace2.read(4)


        feasible_paths = altmeyer - whitham
        ignored_by_wcet = whitham - altmeyer

        out.append((name, '%20s %4u %4u %4u' % (name, len(altmeyer),
                    len(feasible_paths), len(ignored_by_wcet))))
        
        if name == "fac":
            print ' '.join([ hex((x * 16) + 0x8000) for x in altmeyer ])
            print ' '.join([ hex((x * 16) + 0x8000) for x in whitham ])
            print len(whitham)

    out.sort()
    for (_, line) in out:
        print line




